Index: LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90	(revision 987)
@@ -276,19 +276,11 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      INTEGER,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
-
+    INTEGER,DIMENSION(klon_mpi,SIZE(Varout,2)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
+    
   END SUBROUTINE scatter_i1
 
@@ -301,18 +293,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      INTEGER,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    INTEGER,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
     
   END SUBROUTINE scatter_i2
@@ -326,18 +310,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      INTEGER,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    INTEGER,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,4)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,VarOut)
     
   END SUBROUTINE scatter_i3
@@ -369,18 +345,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      REAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    REAL,DIMENSION(klon_mpi,SIZE(Varout,2)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
     
   END SUBROUTINE scatter_r1
@@ -394,18 +362,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      REAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    REAL,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
     
   END SUBROUTINE scatter_r2
@@ -419,18 +379,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      REAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    REAL,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,4)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,VarOut)
     
   END SUBROUTINE scatter_r3
@@ -463,18 +415,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      LOGICAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      LOGICAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    LOGICAL,DIMENSION(klon_mpi,SIZE(Varout,2)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
     
   END SUBROUTINE scatter_l1
@@ -488,19 +432,11 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      LOGICAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
-
+    LOGICAL,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,Varout)
+    
   END SUBROUTINE scatter_l2
 
@@ -513,18 +449,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      LOGICAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-!$OMP MASTER
-        CALL scatter_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-        CALL scatter_omp(Var_tmp,Varout)
-    END SUBROUTINE body
+    LOGICAL,DIMENSION(klon_mpi,SIZE(Varout,2),SIZE(Varout,3),SIZE(Varout,4)) :: Var_tmp
+
+!$OMP MASTER
+      CALL scatter_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+      CALL scatter_omp(Var_tmp,VarOut)
     
   END SUBROUTINE scatter_l3
@@ -562,19 +490,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      INTEGER,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    INTEGER, DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,Varout)
+!$OMP END MASTER
   
   END SUBROUTINE gather_i1
@@ -588,19 +507,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      INTEGER,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    INTEGER, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_i2
@@ -614,19 +524,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      INTEGER,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    INTEGER, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_i3
@@ -659,19 +560,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      REAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    REAL, DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_r1
@@ -685,19 +577,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      REAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    REAL, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_r2
@@ -711,19 +594,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      REAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    REAL, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_r3
@@ -756,19 +630,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      LOGICAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      LOGICAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    LOGICAL, DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_l1
@@ -782,19 +647,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      LOGICAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    LOGICAL, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_l2
@@ -808,19 +664,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      LOGICAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather_mpi(Var_tmp,Varout)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    LOGICAL, DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+    
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE gather_l3
@@ -858,19 +705,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      INTEGER,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarOut,2)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_i1
@@ -884,19 +722,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      INTEGER,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_i2  
@@ -910,19 +739,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      INTEGER,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_i3
@@ -955,19 +775,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      REAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
+    REAL,DIMENSION(klon_mpi,SIZE(VarOut,2)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_r1
@@ -981,19 +792,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      REAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
+    REAL,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_r2  
@@ -1007,19 +809,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      REAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
+    REAL,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_r3
@@ -1053,19 +846,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      LOGICAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarOut,2)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_l1
@@ -1079,19 +863,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      LOGICAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_l2  
@@ -1105,19 +880,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
 
-    CALL body(VarIn,VarOut,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      LOGICAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarOut,2),SIZE(VarOut,3),SIZE(VarOut,4)) :: Var_tmp    
+
 !$OMP MASTER    
-      CALL scatter2D_mpi(VarIn,Var_tmp)
-!$OMP END MASTER
-      CALL scatter_omp(Var_tmp,VarOut)
-
-    END SUBROUTINE body
+    CALL scatter2D_mpi(VarIn,Var_tmp)
+!$OMP END MASTER
+    CALL scatter_omp(Var_tmp,VarOut)
 
   END SUBROUTINE scatter2D_l3
@@ -1150,22 +916,14 @@
     USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi
     IMPLICIT NONE
+  
     INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      INTEGER,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_i1
@@ -1179,19 +937,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      INTEGER,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_i2
@@ -1205,19 +954,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      INTEGER,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    INTEGER,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_i3
@@ -1250,19 +990,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      REAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    REAL,DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_r1
@@ -1276,19 +1007,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      REAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    REAL,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_r2
@@ -1302,19 +1024,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      REAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    REAL,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_r3
@@ -1347,19 +1060,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      LOGICAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      LOGICAL,DIMENSION(klon_mpi,s1) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarIn,2)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_l1
@@ -1373,19 +1077,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      LOGICAL,DIMENSION(klon_mpi,s1,s2) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_l2
@@ -1399,19 +1094,10 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      LOGICAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      LOGICAL,DIMENSION(klon_mpi,s1,s2,s3) :: Var_tmp
-      
-      CALL gather_omp(VarIn,Var_tmp)
-!$OMP MASTER
-      CALL gather2D_mpi(Var_tmp,VarOut)
+    LOGICAL,DIMENSION(klon_mpi,SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4)) :: Var_tmp
+
+    CALL gather_omp(VarIn,Var_tmp)
+!$OMP MASTER
+    CALL gather2D_mpi(Var_tmp,VarOut)
 !$OMP END MASTER    
-
-    END SUBROUTINE body
 
   END SUBROUTINE gather2D_l3
@@ -1446,19 +1132,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      INTEGER,INTENT(IN),DIMENSION(:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      INTEGER,DIMENSION(s1) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    INTEGER,DIMENSION(SIZE(VarIn))   :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_i1  
@@ -1471,19 +1148,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      INTEGER,DIMENSION(s1,s2) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2)) :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_i2  
@@ -1496,19 +1164,10 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      INTEGER,DIMENSION(s1,s2,s3) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))  :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_i3  
@@ -1521,20 +1180,11 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3,s4)
-      INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3,s4
-      INTEGER,DIMENSION(s1,s2,s3,s4) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))  :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
-   
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
   END SUBROUTINE reduce_sum_i4  
 
@@ -1564,19 +1214,10 @@
     REAL,INTENT(OUT),DIMENSION(:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1)
-      REAL,INTENT(IN),DIMENSION(:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:) :: VarOut
-      INTEGER,INTENT(IN) :: s1
-      REAL,DIMENSION(s1) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    REAL,DIMENSION(SIZE(VarIn))   :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_r1  
@@ -1589,19 +1230,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2)
-      REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2
-      REAL,DIMENSION(s1,s2) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2)) :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_r2  
